Index: /LMDZ4/trunk/libf/phylmd/aaam_bud.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/aaam_bud.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/aaam_bud.F	(revision 644)
@@ -0,0 +1,361 @@
+      subroutine aaam_bud (iam,nlon,nlev,rjour,rsec,
+     i                   rea,rg,ome,      
+     i                   plat,plon,phis,
+     i                   dragu,liftu,phyu,
+     i                   dragv,liftv,phyv,
+     i                   p, u, v,
+     o                   aam, torsfc)
+c
+      implicit none
+c======================================================================
+c Auteur(s): F.Lott (LMD/CNRS) date: 20031020
+c Object: Compute different terms of the axial AAAM Budget.
+C No outputs, every AAM quantities are written on the IAM
+C File. 
+c
+c Modif : I.Musat (LMD/CNRS) date : 20041020
+c Outputs : axial components of wind AAM "aam" and total surface torque "torsfc",
+c but no write in the iam file.
+c
+C WARNING: Only valid for regular rectangular grids.
+C REMARK: CALL DANS PHYSIQ AFTER lift_noro:
+C        CALL aaam_bud (27,klon,klev,rjourvrai,gmtime,
+C    C               ra,rg,romega,
+C    C               rlat,rlon,pphis,
+C    C               zustrdr,zustrli,zustrph,
+C    C               zvstrdr,zvstrli,zvstrph,
+C    C               paprs,u,v)
+C
+C======================================================================
+c Explicit Arguments:
+c ==================
+c iam-----input-I-File number where AAMs and torques are written
+c                 It is a formatted file that has been opened
+c                 in physiq.F
+c nlon----input-I-Total number of horizontal points that get into physics
+c nlev----input-I-Number of vertical levels
+c rjour---input-R-Jour compte depuis le debut de la simu (run.def)
+c rsec----input-R-Seconde de la journee
+c rea-----input-R-Earth radius
+c rg------input-R-gravity constant
+c ome-----input-R-Earth rotation rate
+c plat ---input-R-Latitude en degres
+c plon ---input-R-Longitude en degres
+c phis ---input-R-Geopotential at the ground
+c dragu---input-R-orodrag stress (zonal)
+c liftu---input-R-orolift stress (zonal)
+c phyu----input-R-Stress total de la physique (zonal)
+c dragv---input-R-orodrag stress (Meridional)
+c liftv---input-R-orolift stress (Meridional)
+c phyv----input-R-Stress total de la physique (Meridional)
+c p-------input-R-Pressure (Pa) at model half levels
+c u-------input-R-Horizontal wind (m/s)
+c v-------input-R-Meridional wind (m/s)
+c aam-----output-R-Axial Wind AAM (=raam(3))
+c torsfc--output-R-Total surface torque (=tmou(3)+tsso(3)+tbls(3))
+c
+c Implicit Arguments:
+c ===================
+c
+c iim--common-I: Number of longitude intervals
+c jjm--common-I: Number of latitude intervals
+c klon-common-I: Number of points seen by the physics
+c                iim*(jjm-1)+2 for instance
+c klev-common-I: Number of vertical layers
+c======================================================================
+c Local Variables:
+c ================
+c dlat-----R: Latitude increment (Radians)
+c dlon-----R: Longitude increment (Radians)
+c raam  ---R: Wind AAM (3 Components, 1 & 2 Equatoriales; 3 Axiale)
+c oaam  ---R: Mass AAM (3 Components, 1 & 2 Equatoriales; 3 Axiale)
+c tmou-----R: Resolved Mountain torque (3 components)
+c tsso-----R: Parameterised Moutain drag torque (3 components)
+c tbls-----R: Parameterised Boundary layer torque (3 components)
+c
+c LOCAL ARRAY:
+c ===========
+c zs    ---R: Topographic height
+c ps    ---R: Surface Pressure  
+c ub    ---R: Barotropic wind zonal
+c vb    ---R: Barotropic wind meridional
+c zlat  ---R: Latitude in radians
+c zlon  ---R: Longitude in radians
+c======================================================================
+
+#include "dimensions.h"
+#include "dimphy.h"
+c
+c ARGUMENTS
+c
+      INTEGER iam,nlon,nlev
+      REAL rjour,rsec,rea,rg,ome
+      REAL plat(nlon),plon(nlon),phis(nlon)
+      REAL dragu(nlon),liftu(nlon),phyu(nlon)             
+      REAL dragv(nlon),liftv(nlon),phyv(nlon)             
+      REAL p(nlon,nlev+1), u(nlon,nlev), v(nlon,nlev)
+c
+c Variables locales:
+c
+      INTEGER i,j,k,l
+      REAL xpi,hadley,hadday
+      REAL dlat,dlon
+      REAL raam(3),oaam(3),tmou(3),tsso(3),tbls(3)
+      integer iax
+cIM ajout aam, torsfc
+c aam = composante axiale du Wind AAM raam
+c torsfc = composante axiale de (tmou+tsso+tbls)
+      REAL aam, torsfc
+
+      REAL ZS(801,401),PS(801,401)
+      REAL UB(801,401),VB(801,401)
+      REAL SSOU(801,401),SSOV(801,401)
+      REAL BLSU(801,401),BLSV(801,401)
+      REAL ZLON(801),ZLAT(401)
+C
+C  PUT AAM QUANTITIES AT ZERO:
+C
+      if(iim+1.gt.801.or.jjm+1.gt.401)then
+      print *,' Pb de dimension dans aaam_bud'
+      stop
+      endif
+
+      xpi=acos(-1.)
+      hadley=1.e18
+      hadday=1.e18*24.*3600.
+      dlat=xpi/float(jjm)
+      dlon=2.*xpi/float(iim) 
+      
+      do iax=1,3
+      oaam(iax)=0.
+      raam(iax)=0.
+      tmou(iax)=0.
+      tsso(iax)=0.
+      tbls(iax)=0.
+      enddo
+
+C MOUNTAIN HEIGHT, PRESSURE AND BAROTROPIC WIND:
+
+C North pole values (j=1):
+ 
+      l=1
+
+        ub(1,1)=0.
+        vb(1,1)=0.
+        do k=1,nlev
+          ub(1,1)=ub(1,1)+u(l,k)*(p(l,k)-p(l,k+1))/rg
+          vb(1,1)=vb(1,1)+v(l,k)*(p(l,k)-p(l,k+1))/rg
+        enddo
+
+          zlat(1)=plat(l)*xpi/180.
+
+        do i=1,iim+1
+
+          zs(i,1)=phis(l)/rg
+          ps(i,1)=p(l,1)
+          ub(i,1)=ub(1,1)                             
+          vb(i,1)=vb(1,1)                             
+          ssou(i,1)=dragu(l)+liftu(l)
+          ssov(i,1)=dragv(l)+liftv(l)
+          blsu(i,1)=phyu(l)-dragu(l)-liftu(l)
+          blsv(i,1)=phyv(l)-dragv(l)-liftv(l)
+
+        enddo
+
+
+      do j = 2,jjm
+
+C Values at Greenwich (Periodicity)
+
+      zs(iim+1,j)=phis(l+1)/rg
+      ps(iim+1,j)=p(l+1,1)
+          ssou(iim+1,j)=dragu(l+1)+liftu(l+1)
+          ssov(iim+1,j)=dragv(l+1)+liftv(l+1)
+          blsu(iim+1,j)=phyu(l+1)-dragu(l+1)-liftu(l+1)
+          blsv(iim+1,j)=phyv(l+1)-dragv(l+1)-liftv(l+1)
+      zlon(iim+1)=-plon(l+1)*xpi/180.
+      zlat(j)=plat(l+1)*xpi/180.
+
+      ub(iim+1,j)=0.
+      vb(iim+1,j)=0.
+         do k=1,nlev
+         ub(iim+1,j)=ub(iim+1,j)+u(l+1,k)*(p(l+1,k)-p(l+1,k+1))/rg
+         vb(iim+1,j)=vb(iim+1,j)+v(l+1,k)*(p(l+1,k)-p(l+1,k+1))/rg
+         enddo
+      
+
+      do i=1,iim
+
+      l=l+1
+      zs(i,j)=phis(l)/rg
+      ps(i,j)=p(l,1)
+          ssou(i,j)=dragu(l)+liftu(l)
+          ssov(i,j)=dragv(l)+liftv(l)
+          blsu(i,j)=phyu(l)-dragu(l)-liftu(l)
+          blsv(i,j)=phyv(l)-dragv(l)-liftv(l)
+      zlon(i)=plon(l)*xpi/180.
+
+      ub(i,j)=0.
+      vb(i,j)=0.
+         do k=1,nlev
+         ub(i,j)=ub(i,j)+u(l,k)*(p(l,k)-p(l,k+1))/rg
+         vb(i,j)=vb(i,j)+v(l,k)*(p(l,k)-p(l,k+1))/rg
+         enddo
+
+      enddo
+
+      enddo
+
+
+C South Pole
+
+      l=l+1
+      ub(1,jjm+1)=0.
+      vb(1,jjm+1)=0.
+      do k=1,nlev
+         ub(1,jjm+1)=ub(1,jjm+1)+u(l,k)*(p(l,k)-p(l,k+1))/rg
+         vb(1,jjm+1)=vb(1,jjm+1)+v(l,k)*(p(l,k)-p(l,k+1))/rg
+      enddo
+      zlat(jjm+1)=plat(l)*xpi/180.
+
+      do i=1,iim+1
+      zs(i,jjm+1)=phis(l)/rg
+      ps(i,jjm+1)=p(l,1)
+          ssou(i,jjm+1)=dragu(l)+liftu(l)
+          ssov(i,jjm+1)=dragv(l)+liftv(l)
+          blsu(i,jjm+1)=phyu(l)-dragu(l)-liftu(l)
+          blsv(i,jjm+1)=phyv(l)-dragv(l)-liftv(l)
+      ub(i,jjm+1)=ub(1,jjm+1)                               
+      vb(i,jjm+1)=vb(1,jjm+1)                                
+      enddo
+
+C
+C  MOMENT ANGULAIRE 
+C
+        DO j=1,jjm    
+        DO i=1,iim
+
+           raam(1)=raam(1)-rea**3*dlon*dlat*0.5*
+     c    (cos(zlon(i  ))*sin(zlat(j  ))*cos(zlat(j  ))*ub(i  ,j  )
+     c    +cos(zlon(i  ))*sin(zlat(j+1))*cos(zlat(j+1))*ub(i  ,j+1))
+     c                    +rea**3*dlon*dlat*0.5*
+     c    (sin(zlon(i  ))*cos(zlat(j  ))*vb(i  ,j  )
+     c    +sin(zlon(i  ))*cos(zlat(j+1))*vb(i  ,j+1))
+
+           oaam(1)=oaam(1)-ome*rea**4*dlon*dlat/rg*0.5*
+     c   (cos(zlon(i  ))*cos(zlat(j  ))**2*sin(zlat(j  ))*ps(i  ,j  )
+     c   +cos(zlon(i  ))*cos(zlat(j+1))**2*sin(zlat(j+1))*ps(i  ,j+1))
+
+           raam(2)=raam(2)-rea**3*dlon*dlat*0.5*
+     c    (sin(zlon(i  ))*sin(zlat(j  ))*cos(zlat(j  ))*ub(i  ,j  )
+     c    +sin(zlon(i  ))*sin(zlat(j+1))*cos(zlat(j+1))*ub(i  ,j+1))
+     c                    -rea**3*dlon*dlat*0.5*
+     c    (cos(zlon(i  ))*cos(zlat(j  ))*vb(i  ,j  )
+     c    +cos(zlon(i  ))*cos(zlat(j+1))*vb(i  ,j+1))
+
+           oaam(2)=oaam(2)-ome*rea**4*dlon*dlat/rg*0.5*
+     c   (sin(zlon(i  ))*cos(zlat(j  ))**2*sin(zlat(j  ))*ps(i  ,j  )
+     c   +sin(zlon(i  ))*cos(zlat(j+1))**2*sin(zlat(j+1))*ps(i  ,j+1))
+
+           raam(3)=raam(3)+rea**3*dlon*dlat*0.5*
+     c           (cos(zlat(j))**2*ub(i,j)+cos(zlat(j+1))**2*ub(i,j+1))
+
+           oaam(3)=oaam(3)+ome*rea**4*dlon*dlat/rg*0.5*
+     c        (cos(zlat(j))**3*ps(i,j)+cos(zlat(j+1))**3*ps(i,j+1))
+
+        ENDDO
+        ENDDO
+
+C
+C COUPLE DES MONTAGNES:
+C
+
+        DO j=1,jjm
+        DO i=1,iim
+           tmou(1)=tmou(1)-rea**2*dlon*0.5*sin(zlon(i))
+     c  *(zs(i,j)-zs(i,j+1))
+     c  *(cos(zlat(j+1))*ps(i,j+1)+cos(zlat(j))*ps(i,j)) 
+           tmou(2)=tmou(2)+rea**2*dlon*0.5*cos(zlon(i))
+     c  *(zs(i,j)-zs(i,j+1))
+     c  *(cos(zlat(j+1))*ps(i,j+1)+cos(zlat(j))*ps(i,j)) 
+        ENDDO
+        ENDDO
+           
+        DO j=2,jjm 
+        DO i=1,iim
+           tmou(1)=tmou(1)+rea**2*dlat*0.5*sin(zlat(j))
+     c  *(zs(i+1,j)-zs(i,j))
+     c  *(cos(zlon(i+1))*ps(i+1,j)+cos(zlon(i))*ps(i,j))
+           tmou(2)=tmou(2)+rea**2*dlat*0.5*sin(zlat(j))
+     c  *(zs(i+1,j)-zs(i,j))
+     c  *(sin(zlon(i+1))*ps(i+1,j)+sin(zlon(i))*ps(i,j))
+           tmou(3)=tmou(3)-rea**2*dlat*0.5*
+     c  cos(zlat(j))*(zs(i+1,j)-zs(i,j))*(ps(i+1,j)+ps(i,j))
+        ENDDO
+        ENDDO
+
+C
+C COUPLES DES DIFFERENTES FRICTION AU SOL:
+C
+        l=1
+        DO j=2,jjm
+        DO i=1,iim
+        l=l+1
+           tsso(1)=tsso(1)-rea**3*cos(zlat(j))*dlon*dlat*
+     c     ssou(i,j)          *sin(zlat(j))*cos(zlon(i))
+     c                    +rea**3*cos(zlat(j))*dlon*dlat*
+     c     ssov(i,j)          *sin(zlon(i))
+
+           tsso(2)=tsso(2)-rea**3*cos(zlat(j))*dlon*dlat*
+     c     ssou(i,j)          *sin(zlat(j))*sin(zlon(i))
+     c                    -rea**3*cos(zlat(j))*dlon*dlat*
+     c     ssov(i,j)          *cos(zlon(i))
+
+           tsso(3)=tsso(3)+rea**3*cos(zlat(j))*dlon*dlat*
+     c     ssou(i,j)          *cos(zlat(j))
+
+           tbls(1)=tbls(1)-rea**3*cos(zlat(j))*dlon*dlat*
+     c     blsu(i,j)          *sin(zlat(j))*cos(zlon(i))
+     c                    +rea**3*cos(zlat(j))*dlon*dlat*
+     c     blsv(i,j)          *sin(zlon(i))
+
+           tbls(2)=tbls(2)-rea**3*cos(zlat(j))*dlon*dlat*
+     c     blsu(i,j)          *sin(zlat(j))*sin(zlon(i))
+     c                    -rea**3*cos(zlat(j))*dlon*dlat*
+     c     blsv(i,j)          *cos(zlon(i))
+
+           tbls(3)=tbls(3)+rea**3*cos(zlat(j))*dlon*dlat*
+     c     blsu(i,j)          *cos(zlat(j))
+
+        ENDDO
+        ENDDO
+            
+
+c     write(*,*) 'AAM',rsec,
+c     write(*,*) 'AAM',rjour+rsec/86400.,
+c    c      raam(3)/hadday,oaam(3)/hadday,
+c    c      tmou(3)/hadley,tsso(3)/hadley,tbls(3)/hadley
+
+c     write(iam,100)rjour+rsec/86400.,
+c    c      raam(1)/hadday,oaam(1)/hadday,
+c    c      tmou(1)/hadley,tsso(1)/hadley,tbls(1)/hadley,
+c    c      raam(2)/hadday,oaam(2)/hadday,
+c    c      tmou(2)/hadley,tsso(2)/hadley,tbls(2)/hadley,
+c    c      raam(3)/hadday,oaam(3)/hadday,
+c    c      tmou(3)/hadley,tsso(3)/hadley,tbls(3)/hadley 
+100   format(F12.5,15(1x,F12.5))
+
+c     write(iam+1,*)((zs(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((ps(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((ub(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((vb(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((ssou(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((ssov(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((blsu(i,j),i=1,iim),j=1,jjm+1)
+c     write(iam+1,*)((blsv(i,j),i=1,iim),j=1,jjm+1)
+c
+      aam=raam(3)
+      torsfc= tmou(3)+tsso(3)+tbls(3)
+c
+      RETURN
+      END
Index: /LMDZ4/trunk/libf/phylmd/calcul_REGDYN.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calcul_REGDYN.h	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/calcul_REGDYN.h	(revision 644)
@@ -0,0 +1,22 @@
+c
+c $Header$
+c
+c calculs statistiques distribution nuage ftion du regime dynamique 
+c
+c Ce calcul doit etre fait a partir de valeurs mensuelles ??
+      CALL histo_o500_pctau(nbregdyn,pct_ocean,o500,fq_isccp,
+     &histoW,nhistoW)
+c
+c nhistoWt = somme de toutes les nhistoW
+      DO nreg=1, nbregdyn
+       DO k = 1, kmaxm1
+        DO l = 1, lmaxm1
+         DO iw = 1, iwmax
+          nhistoWt(k,l,iw,nreg)=nhistoWt(k,l,iw,nreg)+
+     &    nhistoW(k,l,iw,nreg)
+         ENDDO
+        ENDDO
+       ENDDO
+      ENDDO
+c
+cIM 190504 END
Index: /LMDZ4/trunk/libf/phylmd/calcul_STDlev.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calcul_STDlev.h	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/calcul_STDlev.h	(revision 644)
@@ -0,0 +1,324 @@
+c
+c $Header$
+c
+c
+cIM on initialise les champs en debut du jour ou du mois 
+c
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,tsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,usumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,vsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,wsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,phisumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,qsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,rhsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,uvsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,vqsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,vTsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,wqsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,vphisumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,wTsumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,u2sumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,v2sumSTD)
+        CALL ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $                    tnondef,T2sumSTD)
+c
+cIM on interpole sur les niveaux STD de pression a chaque pas de temps de la physique
+c
+       DO k=1, nlevSTD
+c
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .              t_seri,tlevSTD(:,k))
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             u_seri,ulevSTD(:,k))
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             v_seri,vlevSTD(:,k))
+c
+        DO l=1, klev
+        DO i=1, klon
+         zx_tmp_fi3d(i,l)=paprs(i,l)
+        ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,zx_tmp_fi3d,rlevSTD(k),
+     .             omega,wlevSTD(:,k))
+c
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zphi/RG,philevSTD(:,k))
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             qx(:,:,ivap),qlevSTD(:,k))
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_rh*100.,rhlevSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=u_seri(i,l)*v_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,uvSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=v_seri(i,l)*q_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,vqSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=v_seri(i,l)*t_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,vTSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=omega(i,l)*qx(i,l,ivap)
+         ENDDO !i 
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,wqSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=v_seri(i,l)*zphi(i,l)/RG
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,vphiSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=omega(i,l)*t_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,wTSTD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=u_seri(i,l)*u_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,u2STD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=v_seri(i,l)*v_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,v2STD(:,k))
+c
+        DO l=1, klev
+         DO i=1, klon
+          zx_tmp_fi3d(i,l)=t_seri(i,l)*t_seri(i,l)
+         ENDDO !i
+        ENDDO !l
+        CALL plevel(klon,klev,.true.,pplay,rlevSTD(k),
+     .             zx_tmp_fi3d,T2STD(:,k))
+c
+       ENDDO !k=1,nlevSTD
+c
+cIM on somme les valeurs definies a chaque pas de temps de la physique ou 
+cIM toutes les 6 heures
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.TRUE.
+       CALL undefSTD(nlevSTD,itap,tlevSTD,
+     $               ecrit_hf,
+     $               oknondef,tnondef,tsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,ulevSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,usumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,vlevSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,vsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,wlevSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,wsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,philevSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,phisumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,qlevSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,qsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,rhlevSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,rhsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,uvSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,uvsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,vqSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,vqsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,vTSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,vTsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,wqSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,wqsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,vphiSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,vphisumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,wTSTD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,wTsumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,u2STD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,u2sumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,v2STD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,v2sumSTD)
+c
+       oknondef(1:klon,1:nlevSTD,1:nout)=.FALSE.
+       CALL undefSTD(nlevSTD,itap,T2STD,
+     $           ecrit_hf,
+     $               oknondef,tnondef,T2sumSTD)
+c
+cIM on moyenne a la fin du jour ou du mois 
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,tsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,usumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,vsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,wsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,phisumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,qsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,rhsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,uvsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,vqsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,vTsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,wqsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,vphisumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,wTsumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,u2sumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,v2sumSTD)
+c
+       CALL moy_undefSTD(nlevSTD,itap,
+     $      ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $                   tnondef,T2sumSTD)
+c
+cIM interpolation a chaque pas de temps du SWup(clr) et SWdn(clr) a 200 hPa
+c
+      CALL plevel(klon,klevp1,.true.,paprs,20000.,
+     $     swdn0,SWdn200clr)
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     swdn,SWdn200)
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     swup0,SWup200clr)
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     swup,SWup200)
+c
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     lwdn0,LWdn200clr)
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     lwdn,LWdn200)
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     lwup0,LWup200clr)
+      CALL plevel(klon,klevp1,.false.,paprs,20000.,
+     $     lwup,LWup200)
+c
Index: /LMDZ4/trunk/libf/phylmd/calcul_divers.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calcul_divers.h	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/calcul_divers.h	(revision 644)
@@ -0,0 +1,29 @@
+c
+c $Header$
+c
+c
+c initialisations diverses au "debut" du mois
+c
+      IF(MOD(itap,ecrit_mth).EQ.1) THEN
+         DO i=1, klon
+          nday_rain(i)=0.
+         ENDDO !i
+c
+c surface terre
+       DO i=1, klon
+         IF(pctsrf_new(i,is_ter).GT.0.) THEN
+            paire_ter(i)=airephy(i)*pctsrf_new(i,is_ter)
+         ENDIF 
+       ENDDO
+c
+      ENDIF !MOD(itap,ecrit_mth).EQ.1
+c
+      IF(MOD(itap,ecrit_day).EQ.0) THEN
+c
+cIM calcul total_rain, nday_rain
+c
+       DO i = 1, klon
+        total_rain(i)=rain_fall(i)+snow_fall(i)  
+        IF(total_rain(i).GT.0.) nday_rain(i)=nday_rain(i)+1.
+       ENDDO
+      ENDIF !itap.EQ.ecrit_mth
Index: /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/calcul_simulISCCP.h	(revision 644)
@@ -0,0 +1,160 @@
+c
+c $Header$
+c
+cIM 090704 BEG
+c     nbapp_isccp=48
+c     nbapp_isccp=8
+c     nbapp_isccp=6
+c     nbapp_isccp=4 !CPU < 30min pour  9pdt/jour
+      nbapp_isccp=3 !CPU ??           10pdt/jour
+c     nbapp_isccp=2
+c     nbapp_isccp=1
+      isccppas=NINT(86400./dtime/nbapp_isccp)
+cIM 010904 BEG
+cIM   IF (MOD(itap,isccppas).EQ.0) THEN
+c      PRINT*,'itap,isccppas,xjour',itap,isccppas,xjour
+c
+cIM initialisation nbsunlit pour calculs simulateur ISCCP pdt la journee
+c
+      DO i=1, klon
+       sunlit(i)=1 
+       IF(rmu0(i).EQ.0.) sunlit(i)=0
+       nbsunlit(1,i)=FLOAT(sunlit(i))
+      ENDDO
+c
+cIM calcul tau, emissivite nuages convectifs
+c
+      convfra(:,:)=rnebcon(:,:)
+      convliq(:,:)=rnebcon(:,:)*clwcon(:,:)
+cIM Amip2 beg
+c
+      CALL newmicro (paprs, pplay,ok_newmicro,
+     .            t_seri, convliq, convfra, dtau_c, dem_c,
+     .            cldh_c, cldl_c, cldm_c, cldt_c, cldq_c,
+     .            flwp_c, fiwp_c, flwc_c, fiwc_c,
+     e            ok_aie,
+     e            sulfate, sulfate_pi,
+     e            bl95_b0, bl95_b1,
+     s            cldtaupi, re, fl)
+c
+cIM Amip2 end
+
+c
+cIM calcul tau, emissivite nuages startiformes
+c
+cIM Amip2 beg
+c
+      CALL newmicro (paprs, pplay,ok_newmicro,
+     .            t_seri, cldliq, cldfra, dtau_s, dem_s,
+     .            cldh_s, cldl_s, cldm_s, cldt_s, cldq_s,
+     .            flwp_s, fiwp_s, flwc_s, fiwc_s,
+     e            ok_aie,
+     e            sulfate, sulfate_pi,
+     e            bl95_b0, bl95_b1,
+     s            cldtaupi, re, fl)
+c
+cIM Amip2 end
+c
+      cldtot(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
+c
+cIM inversion des niveaux de pression ==> de haut en bas
+c
+      CALL haut2bas(klon, klev, pplay, pfull)
+      CALL haut2bas(klon, klev, q_seri, qv)
+      CALL haut2bas(klon, klev, cldtot, cc)
+      CALL haut2bas(klon, klev, rnebcon, conv)
+      CALL haut2bas(klon, klev, dtau_s, dtau_sH2B)
+      CALL haut2bas(klon, klev, dtau_c, dtau_cH2B)
+      CALL haut2bas(klon, klev, t_seri, at)
+      CALL haut2bas(klon, klev, dem_s, dem_sH2B)
+      CALL haut2bas(klon, klev, dem_c, dem_cH2B)
+      CALL haut2bas(klon, klevp1, paprs, phalf)
+c
+cIM lecture invtau, tautab des fichiers formattes
+c
+      IF (debut) THEN
+c     open(99,file='tautab.bin',access='sequential',
+c    $     form='unformatted',status='old')
+c     read(99) tautab
+c
+      open(99,file='tautab.formatted', FORM='FORMATTED')
+      read(99,'(f30.20)') tautab
+      close(99)
+c
+      open(99,file='invtau.formatted',form='FORMATTED')
+      read(99,'(i10)') invtau
+      close(99)
+c
+cIM: calcul coordonnees regions pour statistiques distribution 
+cIM: nuages en ftion du regime dynamique pour regions oceaniques
+c
+      IF (ok_regdyn) THEN !histREGDYN
+c
+#include "ini_coord_REGDYN.h"
+c
+      ENDIF !ok_regdyn
+c 
+      ENDIF !debut
+c
+cIM: initialisation de seed
+        DO i=1, klon
+          seed(i)=i+100
+        ENDDO
+c     
+cIM: pas de debug, debugcol
+      debug=0
+      debugcol=0
+c
+cIM o500 ==> distribution nuage ftion du regime dynamique (vit. verticale a 500 hPa)
+c
+        DO k=1, klevm1
+        kp1=k+1
+c       PRINT*,'k, presnivs',k,presnivs(k), presnivs(kp1)
+        if(presnivs(k).GT.50000.AND.presnivs(kp1).LT.50000.) THEN
+         DO i=1, klon
+          o500(i)=omega(i,k)*RDAY/100.
+c         if(i.EQ.1) print*,' 500hPa lev',k,presnivs(k),presnivs(kp1)
+         ENDDO
+         GOTO 1000
+        endif 
+1000  continue
+      ENDDO
+c
+cIM recalcule les nuages vus par satellite, via le simulateur ISCCP
+c
+      CALL ISCCP_CLOUD_TYPES(
+     &     debug,
+     &     debugcol,
+cIM 300704    &     itap, debut,
+cIM 300604 klon !BAD
+     &     klon,
+     &     sunlit,
+     &     klev,
+     &     ncol,
+     &     seed,
+     &     pfull,
+     &     phalf,
+     &     qv, cc, conv, dtau_sH2B, dtau_cH2B,
+     &     top_height,
+     &     overlap,
+     &     tautab,
+     &     invtau,
+     &     ztsol,
+     &     emsfc_lw,
+     &     at, dem_sH2B, dem_cH2B,
+     &     fq_isccp,
+     &     totalcldarea,
+     &     meanptop,
+     &     meantaucld,
+     &     boxtau,
+     &     boxptop)
+c
+c calcul regime dynamique sur les regions fixees
+c
+       IF (ok_regdyn) THEN !histREGDYN
+c
+#include "calcul_REGDYN.h"
+c
+       ENDIF !(ok_regdyn) THEN !histREGDYN
+cIM    ENDIF !(MOD(itaprad,radpas).EQ.0) THEN
+cIM 010904 END
Index: /LMDZ4/trunk/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/clesphys.h	(revision 644)
@@ -22,4 +22,9 @@
 cIM lev_histmth : niveau sorties mensuelles
        INTEGER lev_histhf, lev_histday, lev_histmth
+       CHARACTER*4 type_run
+       LOGICAL ok_isccp, ok_regdyn
+       REAL lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
+       INTEGER ecrit_ins, ecrit_hf, ecrit_hf2mth, ecrit_day
+       INTEGER ecrit_mth, ecrit_tra, ecrit_reg 
 
        COMMON/clesphys/cycle_diurne, soil_model, new_oliq,
@@ -29,2 +34,6 @@
      ,     , top_height, overlap, cdmmax, cdhmax, ksta, ksta_ter
      ,     , ok_kzmin, lev_histhf, lev_histday, lev_histmth
+     ,     , type_run, ok_isccp, ok_regdyn
+     ,     , lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
+     ,     , ecrit_ins, ecrit_hf, ecrit_hf2mth, ecrit_day
+     ,     , ecrit_mth, ecrit_tra, ecrit_reg
Index: /LMDZ4/trunk/libf/phylmd/clesphys.inc
===================================================================
--- /LMDZ4/trunk/libf/phylmd/clesphys.inc	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/clesphys.inc	(revision 644)
@@ -15,4 +15,9 @@
        LOGICAL :: ok_kzmin
        INTEGER :: lev_histhf, lev_histday, lev_histmth
+       CHARACTER (len=4) type_run
+       LOGICAL ok_isccp, ok_regdyn
+       REAL lonmin_ins, lonmax_ins, latmin_ins, latmax_ins
+       INTEGER ecrit_ins, ecrit_hf, ecrit_hf2mth, ecrit_day
+       INTEGER ecrit_mth, ecrit_tra, ecrit_reg
 
        COMMON/clesphys/cycle_diurne, soil_model, new_oliq, &
@@ -21,3 +26,7 @@
      &     , CH4_ppb, N2O_ppb, CFC11_ppt, CFC12_ppt &
      &     , top_height, overlap, cdmmax, cdhmax, ksta, ksta_ter &
-     &     , ok_kzmin, lev_histhf, lev_histday, lev_histmth
+     &     , ok_kzmin, lev_histhf, lev_histday, lev_histmth &
+     &     , type_run, ok_isccp, ok_regdyn &
+     &     , lonmin_ins, lonmax_ins, latmin_ins, latmax_ins &
+     &     , ecrit_ins, ecrit_hf, ecrit_hf2mth, ecrit_day &
+     &     , ecrit_mth, ecrit_tra, ecrit_reg
